; HASP dump header
; 28.05.97 23:56
;
MEMO_BUFFER_SIZE	equ	56
;
; HASP basical services.
;
HASP_INSTALLED		equ	1   ; 01h
HASP_CODE		equ	2   ; 02h
READ_MEMO               equ	3   ; 03h
WRITE_MEMO              equ     4   ; 04h
GET_HASP_STATUS         equ     5   ; 05h
GET_ID_NUM		equ	6   ; 06h
;
MEMOHASP_READ_BLOCK	equ	50  ; 32h
MEMOHASP_WRITE_BLOCK	equ	51  ; 33h
;
; A list of NetHASP services.
;
NET_LAST_STATUS		equ	40  ; 28h
NET_GET_HASP_CODE	equ	41  ; 29h
NET_LOGIN		equ	42  ; 2Ah
NET_LOGOUT		equ	43  ; 2Bh
NET_READ_WORD		equ	44  ; 2Ch
NET_WRITE_WORD		equ	45  ; 2Dh
NET_GET_ID_NUMBER	equ	46  ; 2Eh
NET_READ_MEMO_BLOCK	equ	52  ; 34h
NET_WRITE_MEMO_BLOCK    equ	53  ; 35h
;
; A list of TimeHASP services.
;
TIME_SET_TIME		equ	70  ; 46h
TIME_GET_TIME		equ	71  ; 47h
TIME_SET_DATE		equ	72  ; 48h
TIME_GET_DATE		equ	73  ; 49h
TIME_WRITE_MEMORY	equ	74  ; 4Ah
TIME_READ_MEMORY	equ	75  ; 4Bh
TIME_WRITE_MEMORY_BLOCK	equ	76  ; 4Ch
TIME_READ_MEMORY_BLOCK	equ	77  ; 4Dh
TIME_GET_ID_NUM         equ	78  ; 4Eh
;
;
OK			equ	0   ;
NET_READ_ERROR		equ	131 ; 83h
NET_WRITE_ERROR		equ	132 ; 84h
;
OTHER_BLOCK_OP_MIN	equ	81  ; 51h
OTHER_BLOCK_OP_MAX	equ	99  ; 63h
;
;
; HASP block services. (compatibility list)
;
MEMOHASP_READ_BLOCK	equ	50
MEMOHASP_WRITE_BLOCK	equ	51
NETHASP_READ_BLOCK	equ	52
NETHASP_WRITE_BLOCK	equ	53
TIMEHASP_WRITE_BLOCK	equ	76
TIMEHASP_READ_BLOCK	equ	77
;
_HaspDumpHdr struc
	l_hdr		db	?
	_hdr		db	8 dup  (?)	; 'Hasp 1.2'
	l_date		db	?
	_dateX		db	16 dup (?)	; '28.05.97 23:56'
	_type		dw	?		; HASP type
	_misc		dd	?		;
	_pwdHi		dw	?
  	_pwdLo		dw	?
	_sn		dd	?		; serial nu
   	_misc1		db	8 dup (?)	;
   	_bf		dw	MEMO_BUFFER_SIZE dup (?)
_HaspDumpHdr ends
;
$PAS		equ	0
$C		equ	1
$FoxP		equ	3
;
IFDEF _PASCAL_
RetCode4	equ	[bp+6h]
RetCode3 	equ	[bp+0Ah]
RetCode2	equ	[bp+0Eh]
RetCode1	equ	[bp+12h]
PlugNameHi	equ	[bp+16h]
PlugNameLow	equ	[bp+18h]
lptNum		equ	[bp+1Ah]
SeedCode	equ	[bp+1Ch]
Cmd		equ	[bp+1Eh]
ENDIF
;
IFDEF _FOXPRO_
RetCode4	equ	[BP+28]
RetCode3	equ	[BP+24]
RetCode2	equ	[BP+20]
RetCode1	equ	[BP+16]
PlugNameHi	equ	[BP+14]
PlugNameLow	equ	[BP+12]
lptnum		equ	[BP+10]
SeedCode	equ	[BP+8 ]
Cmd		equ	[BP+6 ]
ENDIF

IFDEF _FOXPRO
_hasp		proc   far
		push	bp
		mov	bp,sp
		push	es
		push	di			; save registers
		push	si
		push	ax
		push	bx
		push	cx
		push	dx

		les	si,RetCode1
		mov	di,es:[si]		; memory address

		mov	bx,Cmd
		xchg	bh,bl
		add	bx,lptnum

		mov	ax,SeedCode
		mov	cx,PlugNameLow
		mov	dx,PlugNameHi

		cmp	bh, MEMOHASP_READ_BLOCK
		jb	NotBlockOperation
		les	si, RetCode4
		mov	ax, es:[si]		; the offset of the block
NotBlockOperation:

		les	si,RetCode2
		mov	si,es:[si]		; memory data

		cmp	bh, MEMOHASP_READ_BLOCK
		jb	NotBlock1
		cmp	bh, MEMOHASP_READ_BLOCK
		je	BlockOp
		cmp	bh, MEMOHASP_WRITE_BLOCK
		je	BlockOp
		cmp	bh, NETHASP_READ_BLOCK
		je	BlockOp
		cmp	bh, NETHASP_WRITE_BLOCK
		je	BlockOp
		cmp	bh, TIMEHASP_WRITE_BLOCK
		je	BlockOp
		cmp	bh, TIMEHASP_READ_BLOCK
		je	BlockOp
	  	cmp	bh, OTHER_BLOCK_OP_MIN
		jb	NotBlock1
		cmp	bh, OTHER_BLOCK_OP_MAX
		ja	NotBlock1

BlockOp:
		push	si
		les	si, RetCode3
		mov	es, es:[si]		; the segment of the block
		pop	si
		jmp	short NotBlock1
;
db		'[ HASP Suxx!!!! ]'		; What HASP mean for me... ;)
;
NotBlock1:
		push	bp
		call	phuck_hasp
		pop	bp

;
; Store the returned values into p1...p4
;
		les	di, RetCode1
patch_bytes	equ	$
		mov	es:[di], ax
		les	di, RetCode2
		mov	es:[di], bx
		les	di, RetCode3
		mov	es:[di], cx
		les	di, RetCode4
		mov	es:[di], dx

		pop	dx
		pop	cx
		pop	bx
		pop	ax
		pop	si
		pop	di
		pop	es

		pop	bp
		retf
_hasp	      endp
ENDIF
;
IFDEF _C_
_hasp		proc   far
		mov	bp, sp
		push	es
		push	di
		push	si
		les	si, [bp+10h]
		mov	di, es:[si]
		mov	bx, [bp+6]
		xchg	bh, bl
		add	bx, [bp+0Ah]
		mov	ax, [bp+8]
		mov	cx, [bp+0Ch]
		mov	dx, [bp+0Eh]
		cmp	bh, 32h	; '2'
		jb	loc_0_27
		les	si, [bp+1Ch]
		mov	ax, es:[si]

loc_0_27:				; CODE XREF: sub_0_0+1Fj
		les	si, [bp+14h]
		mov	si, es:[si]
		push	si
		les	si, [bp+18h]
		push	word ptr es:[si]
		pop	es
		pop	si
		push	bp
		call	phuck_hasp
		pop	bp
		les	di, [bp+10h]
		mov	es:[di], ax
		les	di, [bp+14h]
		mov	es:[di], bx
		les	di, [bp+18h]
		mov	es:[di], cx
		les	di, [bp+1Ch]
		mov	es:[di], dx
		pop	si
		pop	di
		pop	es
		pop	bp
		retf
_hasp	      endp
ENDIF
;
IFDEF _PASCAL_
		retf	1Ah
ENDIF

